Imports System.Xml.Serialization
Imports System.Xml
Imports System.Data.Odbc
Imports System.IO
Imports System.IO.Compression
Imports System.Diagnostics
Imports Ionic.Utils.Zip

Public Class ACPGenerator
    Public aFields() As String
    Public aTypeFields() As String
    Dim i As Integer
    Dim j As Integer

    Private Sub btnBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowse.Click
        'Select Alfresco Custom Content Model
        If FolderBrowserDialog.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.txtPath1.Text = FolderBrowserDialog.SelectedPath
        End If
    End Sub


    Public Function getXml(ByVal parameter As String, ByVal strXmlFileUrl As String) As String
        ' Read the Alfresco Custom Content Model
        Try
            Dim xmlFilename As String = strXmlFileUrl
            Dim XmlTextReader As New XmlTextReader(strXmlFileUrl)
            XmlTextReader.WhitespaceHandling = WhitespaceHandling.None

            While XmlTextReader.Read
                Select Case XmlTextReader.NodeType
                    Case XmlNodeType.Element
                        If XmlTextReader.Name = parameter And parameter = "type" Then
                            getXml = XmlTextReader.GetAttribute(0)
                            Exit While
                        End If
                        If XmlTextReader.Name = parameter And parameter = "namespace" Then
                            getXml = XmlTextReader.GetAttribute(0) & "|" & XmlTextReader.GetAttribute(1)
                            Exit While
                        End If
                End Select
            End While
            XmlTextReader.Close()
        Catch ex As Exception
            Throw ex
        End Try
    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim PathA As String
        Dim ary(1) As String
        Dim docType() As String
        Dim dir As DirectoryInfo
        Dim dirs() As String
        Dim Pathcsv As String
        Dim PathModel As String
        Dim dirFiles() As String
        Dim dirFolder() As String

        Try
            If Me.txtPath1.Text = String.Empty Then
                MessageBox.Show("Select Alfresco ACP Path", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            Else
                PathA = Me.txtPath1.Text
            End If
            'Get CSV file and Alfresco Custom Content Model paths
            dirs = Directory.GetFiles(PathA & "\definition_files")
            For i = 0 To dirs.Length - 1
                If (Path.GetFileName(dirs(i)).Split(".")(1)).ToLower = "csv" Then
                    Pathcsv = Path.GetFileName(dirs(i))
                ElseIf Path.GetFileName(dirs(i)).Split(".")(1) = "xml" And Path.GetFileName(dirs(i)) <> "headerxml.xml" Then
                    PathModel = dirs(i)
                End If
            Next
            'Read CSV file and Alfresco Custom Content Model
            Dim con As New OdbcConnection("Driver={Microsoft Text Driver (*.txt; *.csv)};Dbq=" & Me.txtPath1.Text & "\definition_files" & ";	Extensions=asc,csv,tab,txt;Persist Security Info=False")
            Dim com As New OdbcCommand
            Dim da As New OdbcDataAdapter
            Dim ds As New DataSet
            com.Connection = con

            com.CommandType = CommandType.Text
            com.CommandText = "select * from " & Pathcsv
            If con.State = ConnectionState.Closed Then
                con.Open()
            End If

            da.SelectCommand = com
            Try
                da.Fill(ds)
            Catch ex As Exception
                MessageBox.Show("Error : Path ", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End Try

            ' Create The Output folder if not exist
            If Directory.Exists(PathA & "\Output") Then
                Directory.Delete(PathA & "\Output", True)
            End If
            dir = Directory.CreateDirectory(PathA & "\Output")

            'Copy Documetns to the Output folder
            CopyFolder(PathA & "\Content", PathA & "\Output\infoImagXML")

            'Create ACP XML file 
            Dim settings As New XmlWriterSettings()
            settings.Indent = True
            settings.NewLineOnAttributes = True

            Dim tw As XmlTextWriter

            If Not Directory.Exists(PathA & "\Output\infoImagXML.xml") Then
                tw = New XmlTextWriter(PathA & "\Output\infoImagXML.xml", New System.Text.UTF8Encoding())
                tw.Formatting = Formatting.Indented
                tw.Indentation = 4

                tw.WriteStartDocument()
                tw.WriteStartElement("view", "view", "http://www.alfresco.org/view/repository/1.0")
                tw.WriteStartElement("view", "metadata", "http://www.alfresco.org/view/repository/1.0")

                tw.WriteStartElement("view", "exportBy", "http://www.alfresco.org/view/repository/1.0")
                tw.WriteValue("admin")
                tw.WriteEndElement()

                tw.WriteStartElement("view", "exportDate", "http://www.alfresco.org/view/repository/1.0")
                tw.WriteValue("2007-04-24T17:30:48.535+01:00")
                tw.WriteEndElement()

                tw.WriteStartElement("view", "exporterVersion", "http://www.alfresco.org/view/repository/1.0")
                tw.WriteValue("1.4.0 (build-105)")
                tw.WriteEndElement()

                tw.WriteStartElement("view", "exportOf", "http://www.alfresco.org/view/repository/1.0")
                tw.WriteValue("/app:company_home/cm:Published")
                tw.WriteEndElement()

                tw.WriteEndElement()

                For j As Integer = 0 To ds.Tables(0).Rows.Count - 1
                    docType = getXml("type", PathModel).Split(":")
                    tw.WriteStartElement(docType(0) & ":" & docType(1))
                    tw.WriteAttributeString("xmlns", "")
                    tw.WriteAttributeString("xmlns:nt", "http://www.jcp.org/jcr/nt/1.0")
                    tw.WriteAttributeString("xmlns:app", "http://www.alfresco.org/model/application/1.0")
                    tw.WriteAttributeString("xmlns:d", "http://www.alfresco.org/model/dictionary/1.0")
                    tw.WriteAttributeString("xmlns:sys", "http://www.alfresco.org/model/system/1.0")
                    tw.WriteAttributeString("xmlns:alf", "http://www.alfresco.org")
                    tw.WriteAttributeString("xmlns:ver", "http://www.alfresco.org/model/versionstore/1.0")
                    tw.WriteAttributeString("xmlns:mix", "http://www.jcp.org/jcr/mix/1.0")
                    tw.WriteAttributeString("xmlns:bpm", "http://www.alfresco.org/model/bpm/1.0")
                    tw.WriteAttributeString("xmlns:jcr", "http://www.jcp.org/jcr/1.0")
                    tw.WriteAttributeString("xmlns:fm", "http://www.alfresco.org/model/forum/1.0")
                    tw.WriteAttributeString("xmlns:cm", "http://www.alfresco.org/model/content/1.0")
                    tw.WriteAttributeString("xmlns:rule", "http://www.alfresco.org/model/rule/1.0")
                    tw.WriteAttributeString("xmlns:dm", "dm.new.model")
                    tw.WriteAttributeString("xmlns:sv", "http://www.jcp.org/jcr/sv/1.0")
                    tw.WriteAttributeString("xmlns:usr", "http://www.alfresco.org/model/user/1.0")
                    tw.WriteAttributeString("xmlns:view", "http://www.alfresco.org/view/repository/1.0")
                    tw.WriteAttributeString("xmlns:act", "http://www.alfresco.org/model/action/1.0")
                    tw.WriteAttributeString("xmlns:wf", "http://www.alfresco.org/model/workflow/1.0")
                    tw.WriteAttributeString("xmlns:" & getXml("namespace", PathModel).Split("|")(1), getXml("namespace", PathModel).Split("|")(0))

                    tw.WriteAttributeString("xmlns:custom", "custom.model")
                    tw.WriteAttributeString("view:childName", "cm:" & ds.Tables(0).Rows(j).Item(0))

                    tw.WriteStartElement("view:aspects")

                    tw.WriteStartElement("cm:auditable")
                    tw.WriteEndElement()
                    tw.WriteStartElement("sys:referenceable")
                    tw.WriteEndElement()
                    tw.WriteStartElement("cm:titled")
                    tw.WriteEndElement()
                    tw.WriteStartElement("cm:author")
                    tw.WriteEndElement()
                    tw.WriteStartElement("app:inlineeditable")
                    tw.WriteEndElement()

                    tw.WriteEndElement()


                    tw.WriteStartElement("view:properties")
                    tw.WriteStartElement("cm:name")
                    tw.WriteValue(ds.Tables(0).Rows(j).Item(0))
                    tw.WriteEndElement()
                    tw.WriteStartElement("sys:node-dbid")
                    tw.WriteEndElement()
                    tw.WriteStartElement("sys:store-identifier")
                    tw.WriteValue("SpacesStore")
                    tw.WriteEndElement()
                    tw.WriteStartElement("cm:content")
                    tw.WriteValue("contentUrl=infoImagXML/" & ds.Tables(0).Rows(j).Item(0) & "|mimetype=application/" & ds.Tables(0).Rows(0).Item(0).Split(".")(1) & "|size=15|encoding=UTF-8")
                    tw.WriteEndElement()
                    tw.WriteStartElement("cm:title")
                    tw.WriteValue(ds.Tables(0).Rows(j).Item(0))
                    tw.WriteEndElement()
                    tw.WriteStartElement("sys:node-uuid")
                    tw.WriteEndElement()
                    tw.WriteStartElement("cm:author")
                    tw.WriteValue("InfoImag Capture Tool")
                    tw.WriteEndElement()
                    tw.WriteStartElement("cm:modifier")
                    tw.WriteValue("InfoImag Capture Tool")
                    tw.WriteEndElement()
                    tw.WriteStartElement("cm:modified")
                    tw.WriteValue("2008-09-23T13:50:49.000+01:00")
                    tw.WriteEndElement()
                    tw.WriteStartElement("app:editInline")
                    tw.WriteValue("true")
                    tw.WriteEndElement()
                    tw.WriteStartElement("sys:store-protocol")
                    tw.WriteValue("workspace")
                    tw.WriteEndElement()
                    tw.WriteStartElement("cm:creator")
                    tw.WriteValue("InfoImag Capture Tool")
                    tw.WriteEndElement()
                    tw.WriteStartElement("cm:description")
                    tw.WriteValue(ds.Tables(0).Rows(j).Item(0))
                    tw.WriteEndElement()
                    tw.WriteStartElement("cm:categories")
                    tw.WriteStartElement("view:values")
                    tw.WriteEndElement()
                    tw.WriteEndElement()
                    tw.WriteStartElement("cm:created")
                    tw.WriteValue("2008-09-23T13:50:49.000+01:00")
                    tw.WriteEndElement()

                    For t As Integer = 0 To ds.Tables(0).Columns.Count - 1
                        If t <> 0 Then
                            tw.WriteStartElement(ds.Tables(0).Columns(t).Caption)
                            If IsDate(ds.Tables(0).Rows(j).Item(t)) Then
                                Dim d As Date = ds.Tables(0).Rows(j).Item(t)
                                Dim strin As String = d.ToString("yyyy-MM-dd")
                                tw.WriteValue(strin & "T00:00:00.000+01:00")
                            Else
                                tw.WriteValue(ds.Tables(0).Rows(j).Item(t))
                            End If
                            tw.WriteEndElement()
                        End If
                    Next

                    tw.WriteEndElement()

                    tw.WriteStartElement("view:associations")
                    tw.WriteEndElement()

                    tw.WriteEndElement()
                Next

                tw.WriteEndDocument()
                tw.Close()

                'Compress both Documents and ACP XML file and convert them to .ACP file
                Dim zip As New ZipFile(PathA & "\Output\Output.acp")
                zip.AddItem(PathA & "\Output")
                zip.Save()

                MessageBox.Show("ACP Generated Successfully", "ACP Generator", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    Public Sub CopyFolder(ByVal sourceFolder As String, ByVal destFolder As String)
        Try
            Dim arrPath() As String
            If Not Directory.Exists(destFolder) Then
                Directory.CreateDirectory(destFolder)
                arrPath = Directory.GetFiles(sourceFolder)
                For Each fil As String In arrPath
                    Dim name As String = Path.GetFileName(fil)
                    Dim dest As String = Path.Combine(destFolder, name)
                    File.Copy(fil, dest)
                Next
            End If
        Catch ex As Exception
            Throw ex
        End Try
    End Sub
End Class